<script lang="ts">
  import { getLocalizer } from '../../../module/utils.js'
  import Liturgy from './Liturgy.svelte'

  import { getContext } from 'svelte'
  import { CharacterDataAccessor } from '../../../module/model/character.js'
  import { Writable } from 'svelte/store'
  import { hasName } from '../../../module/model/utils.js'

  const localize = getLocalizer()

  let doc = getContext<Writable<CharacterDataAccessor>>('doc')

  $: liturgies = $doc.liturgies
  $: sortedLiturgies = liturgies
    .filter(hasName)
    .sort((a, b) => a.name.localeCompare(b.name))
</script>

<div class="liturgies">
  <div class="head">
    <div class="liturgy-label">{localize('name')}</div>
    <div class="liturgy-attributes">
      <div>{localize('degree')}</div>
      <div>{localize('targetClasses')}</div>
      <div>{localize('range')}</div>
      <div>{localize('liturgyCastTime')}</div>
    </div>
  </div>
  {#each sortedLiturgies as liturgy}
    <div class="liturgy">
      <Liturgy bind:liturgy />
    </div>
  {/each}
</div>

<style>
  .head {
    font-weight: bold;
    font-size: medium;
    margin-top: 20px;
    display: flex;
  }

  .liturgy-attributes {
    display: flex;
    justify-content: space-between;
    width: 60%;
  }

  .liturgy-label {
    width: 40%;
  }

  .liturgy:nth-child(even) {
    background-color: rgba(255, 255, 255, 0.2);
  }
</style>
